AddDamageType("Deathray", '%1 deathrayed himself!', '%2 deathrayed %1!', 1, 1);

package deathray
{
	function DeathrayProjectile::onCollision(%data, %obj, %col, %fade, %pos, %normal)
	{
		Parent::onCollision(%data, %obj, %col, %fade, %pos, %normal);
		if(%col.getType() & $Typemasks::PlayerObjectType)
			%col.setDamageLevel(%col.getDatablock().maxDamage - 100);
	}
};
activatePackage(deathray);

datablock particleData(DeathrayParticle)
{
	dragCoefficient = 0;
	gravityCoefficient = 0;
	inheritedVelFactor = 0;
	constantAcceleration = 0;
	lifetimeMS = 1000;
	lifetimeVarianceMS = 0;
	spinSpeed = 0;
	spinRandomMin = 0;
	spinRandomMax = 0;
	textureName = "base/data/particles/cloud";
	colors[0] = "0.6 0 1 1";
	sizes[0] = 1;
	times[0] = 0;
	colors[1] = "0 0 0 0";
	sizes[1] = 1;
	times[1] = 1;
	useInvAlpha = false;
};

datablock particleEmitterData(DeathrayExplosionEmitter)
{
	ejectionPeriodMS = 2;
	periodVarianceMS = 0;
	ejectionVelocity = 1.0;
	velocityVariance = 0.2;
	ejectionOffset = 0.0;
	thetaMin = 0;
	thetaMax = 90;
	lphiReferenceVel = 0;
	lphiVariance = 360;
	overrideAdvance = false;
	particles = "DeathrayParticle";
};

datablock explosionData(DeathrayExplosion)
{
	lifetimeMS = 1500;
	particleEmitter = DeathrayExplosionEmitter;
	particleDensity = 300;
	particleRadius = 1;
	shakeCamera = false;
	camShakeFreq = "0.0 0.0 0.0";
	camShakeAmp = "0.0 0.0 0.0";
	camShakeDuration = 0.0;
	camShakeRadius = 0.0;
	camShakeFalloff = 0.0;
	explosionScale = "1 1 1";
	damageRadius = 0;
	radiusDamage = 0;
	impulseForce = 0;
};

datablock particleEmitterData(DeathrayEmitter)
{
	ejectionPeriodMS = 2;
	periodVarianceMS = 0;
	ejectionVelocity = 0.0;
	velocityVariance = 0.0;
	ejectionOffset = 0.0;
	thetaMin = 0;
	thetaMax = 90;
	lphiReferenceVel = 0;
	lphiVariance = 360;
	overrideAdvance = false;
	particles = "DeathrayParticle";
};

datablock projectileData(DeathrayProjectile)
{
	directDamage = 10000;
	directDamageType = $DamageType::Deathray;
	radiusDamageType = $DamageType::Deathray;
	explosion = DeathrayExplosion;
	particleEmitter = DeathrayEmitter;
	uiName = "";
	gravityMod = 1;
	lifetime = 30000;
	muzzleVelocity = 200;
};

datablock itemData(DeathrayItem)
{
	shapeFile = "Add-Ons/Weapon_Deathray/Item.dts";
	colorShiftColor = "0.600000 0.000000 1.000000 1.000000";
	image = DeathrayImage;
	uiName = "Deathray";
};

datablock shapeBaseImageData(DeathrayImage)
{
	armReady = true;
	className = "WeaponImage";
	colorShiftColor = "0.600000 0.000000 1.000000 1.000000";
	correctMuzzleVector = true;
	doColorShift = true;
	emap = true;
	eyeOffset = "0 0 0";
	melee = false;
	mountPoint = 0;
	muzzleVelocity = 1000;
	projectile = DeathrayProjectile;
	projectileType = Projectile;
	shapeFile = "base/data/shapes/empty.dts";
	offset = "0 0 0";
	rotation = "1 0 0 0";
	item = DeathrayItem;
	ammo = " ";
	
	stateName[0] = "Initial";
	stateTimeoutValue[0] = 0.15;
	stateTransitionOnTimeout[0] = "Ready";
	
	stateName[1] = "Ready";
	stateAllowImageChange[1] = true;
	stateTransitionOnTriggerDown[1] = "Fire";
	
	stateFire[2] = true;
	stateName[2] = "Fire";
	stateScript[2] = "onFire";
	stateAllowImageChange[2] = false;
	stateTimeoutValue[2] = 0.05;
	stateTransitionOnTimeout[2] = "Reload";
	
	stateName[3] = "Reload";
	stateAllowImageChange[3] = false;
	stateTimeoutValue[3] = 0.05;
	stateTransitionOnTimeout[3] = "Fire";
	stateTransitionOnTriggerUp[3] = "Ready";
};

function 